package com.jh.common.template.customizable;

import java.util.Collection;
import java.util.List;

import javax.persistence.Query;

import org.springframework.stereotype.Repository;

import com.jh.common.jpa.AbstractHibernateRepository;
import com.jh.common.template.Template;


@Repository
public class CustomizableLabelsRepository extends AbstractHibernateRepository {

	
	@SuppressWarnings("unchecked")
	public Template fetchTemplate(String code) {
		Query q = entityManager.createQuery("select t from Template t where code = :code");
		q.setParameter("code", code);
		List<Template> list = q.getResultList();
		return list.isEmpty() ? null : list.get(0);
	}


	@SuppressWarnings("unchecked")
	public List<CustomizableTemplateLabel> findCustomizedTemplateLabels(Long templateId, Long unitId) {
		Query q = entityManager.createQuery("select tl from TemplateLabel tl left join tl.template t where t.id = :templateId and tl.unitId = :unitId order by tl.position asc");
		
		q.setParameter("template.id", templateId);
		q.setParameter("unitId", unitId);
		
		return q.getResultList();
	}


	@SuppressWarnings("unchecked")
	public List<CustomizableTemplateLabel> findDefaultTemplateLabels(Long templateId) {
		Query q = entityManager.createQuery("select tl from TemplateLabel tl left join tl.template t where t.id = :templateId and tl.unitId is null");
		q.setParameter("template.id", templateId);
		return q.getResultList();
	}


	public void saveCustomizedLabels(Collection<CustomizableTemplateLabel> labels) {
		if (labels == null) {
			return;
		}
		labels.stream().forEach(this::save);
	}



}
